<?php
defined('_JEXEC') or die('Direct Access to '.basename(__FILE__).' is not allowed.');

jimport('joomla.event.plugin');

class plgSystemLoginRedirect extends JPlugin
{
	/**
	 * This event is triggered after the framework has loaded and initialised and the router has route the client request.
	 * Routing is the process of examining the request environment to determine which component should receive the request. This component optional parameters are then set in the request object to be processed when the application is being dispatched.
	 * When this event triggers the router has parsed the route and pushed the request parameters into JRequest for retrieval by the application.
	 *
	 * @return none
	 */
	function onAfterRoute()
	{
		// set login return URL
		$this->DoLoginReturn();
	}

	function DoLoginReturn()
	{
		$app 			=& JFactory::getApplication();
		$uri 			= JFactory::getURI();
		$currentURL		= $uri->toString(array('path', 'query', 'fragment'));
		$previousURLs 	= unserialize($app->getUserState(__CLASS__.__FUNCTION__));
		
		if (!$previousURLs)
		{
			$previousURLs = array();
		}
		
		if (JRequest::getCmd('option') != 'com_user')
		{
			$previousURLs[] = $currentURL;
		}
		
		if (count($previousURLs) > 5)
		{
			array_shift($previousURLs);
		}
		
		$app->setUserState(__CLASS__.__FUNCTION__, serialize($previousURLs));
		
		$previousURLs = array_reverse($previousURLs);
		JRequest::setVar('return', base64_encode($previousURLs[0]));
	}
}
?>